unit Form_Main;

interface

uses
  Windows, Messages, SysUtils, ShellAPI, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, mmSystem, ThemeMgr;

type
  TTCPD_Main = class(TForm)
    Image_Banner: TImage;
    Label1: TLabel;
    Image_HD: TImage;
    Btn_OK: TBitBtn;
    Btn_Cancel: TBitBtn;
    Edit_Password: TEdit;
    ThemeManager1: TThemeManager;
    procedure Btn_CancelClick(Sender: TObject);
    procedure Edit_PasswordKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure Btn_OKClick(Sender: TObject);
    procedure Image_BannerDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  TCPD_Main: TTCPD_Main;

implementation

uses Form_Config, U_Basic, U_Constants;

{$R *.DFM}

{==============================================================================}

procedure TTCPD_Main.Btn_CancelClick(Sender: TObject);
begin
  Close;
end;
{==============================================================================}

procedure TTCPD_Main.Edit_PasswordKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Btn_OKClick(Self);
  end;
end;
{==============================================================================}

procedure TTCPD_Main.FormCreate(Sender: TObject);
begin
  Edit_Password.Text := '';
  TCPD_Config.Caption := TCPD_Config.Caption + ' ' + AppVersionStr;
end;
{==============================================================================}

procedure TTCPD_Main.Btn_OKClick(Sender: TObject);
var i: Integer;
  Error: Boolean;
begin
  Visible := False;
  Error := False;
  try

    if FileExists(TCPD_Config.Edit_Executable.Text) then
    begin

      for i := TCPD_Config.Memo_Params.Lines.Count - 1 downto 0 do
        if Trim(TCPD_Config.Memo_Params.Lines[i]) = '' then TCPD_Config.Memo_Params.Lines.Delete(i);

      TCPD_Config.SaveToRegistry;

      if TCPD_Config.Memo_Params.Lines.Count > 0 then
      begin
        for i := 0 to TCPD_Config.Memo_Params.Lines.Count - 1 do
          ExecAndWait(TCPD_Config.Edit_Executable.Text, StringReplace(TCPD_Config.Memo_Params.Lines[i], '%PASSWORD%', Edit_Password.Text, [rfReplaceAll, rfIgnoreCase]), sw_ShowNormal);
      end
      else
      begin
        Error := True;
        MessageDlg('No TrueCrypt command line params given in the configuration dialog!' + #13#10 +
          'Please double click on the top image in the password dialog to open the configuration dialog.', mtWarning, [mbOk], 0);
      end;


      if FileExists(TCPD_Config.Edit_sound.text) then
        PlaySound(PChar(TCPD_Config.Edit_sound.text), HInstance, SND_SYNC);
    end
    else
    begin
      Error := True;
      MessageDlg('TrueCrypt executable (' + TCPD_Config.Edit_Executable.Text + '), given in the configuration dialog, do not exists.' + #13#10 +
        'Please double click on the top image in the password dialog to open the configuration dialog.', mtWarning, [mbOk], 0);
    end;

  finally
    Visible := True;
    if not Error then Close;
  end;
end;
{==============================================================================}

procedure TTCPD_Main.Image_BannerDblClick(Sender: TObject);
begin
  TCPD_Config.ShowModal;
end;
{==============================================================================}

procedure TTCPD_Main.FormShow(Sender: TObject);
begin
  TCPD_Config.LoadFromRegistry;
end;
{==============================================================================}
end.

